C
C  PROGRAM FOR THE CALCULATION OF THE AE3 TEMPERATURE
C  FOR LOW-ALLOY STEELS
C  COPYRIGHT A A B Sugden & H K D H Bhadeshia 1985 
C  ELEMENTS MUST BE INSERTED IN THE DATASET IN THE ORDER: 
C  Mn Si Ni Cr Mo Cu V Nb W Co C 
C
      IMPLICIT DOUBLE PRECISION (T)
      DOUBLE PRECISION A(10),AC,AI(10),B(10,5),C,C6,CAF,CF,CLIQ
      DOUBLE PRECISION DAT(10),DELTAT,DTGAM,E(10,4),FEAF,G,GC,GI
      DOUBLE PRECISION H,H1,P,Q,R,WTPC,X(10),XX(10),Z,Z61
      DOUBLE PRECISION HK(13),HC(13)
      COMMON /INTER/B
      COMMON /DELTA2/E
      COMMON /PARMS/G,R,TO,T,P,CF,Q,GC,GI,H1,H
      INTEGER COUNT,COUNTA,DUMMY,FLAG2,NCAP7,IFAIL,S91
      COUNTA = 2
      K = 2
      MM = 2
      NCAP7 = 13
      IFAIL = 0
      R = 1.9858D0
C                 cal/mol/K
      DATA C, SUM, DELTAT/0.0D0, 0.0D0, 0.0D0/
      DATA TEMP, TT, Z/0.0D0, 0.0D0, 0.0D0/
C
C  SPLINE COEFFICIENTS FOR DELTAoHo
C  INTERPOLATES DATA FROM KAUFMAN, CLOUGHERTY, AND WEISS (RANGE 0-1183K)
C
      DATA HK(1),HK(2),HK(3),HK(4)/0.0D0,0.0D0,0.0D0,0.0D0/,
     * HK(5),HK(6),HK(7),HK(8),HK(9)/1.5D2,3.0D2,7.2D2,9.6D2,1.08D3/,
     * HK(10),HK(11),HK(12),HK(13)/1.183D3,1.183D3,1.183D3,1.183D3/,
     * HC(1),HC(2),HC(3),HC(4)/1.303D3,1.272D3,1.368D3,1.703D3/,
     * HC(5),HC(6),HC(7),HC(8)/1.552D3,1.281D3,3.359D2,2.344D2/,
     * HC(9),HC(10),HC(11),HC(12)/2.134D2,0.0D0,0.0D0,0.0D0/,
     * HC(13)/0.0D0/
C *****************************************************
      WRITE(6,*) 'Input  Mn  Si  Ni  Cr  Mo  Cu  V  Nb  W  Co wt%:'
      READ(5,*) (DAT(I),I=1,10)
      WRITE(6,101)
      WRITE(6,51)
      WRITE(6,301)
      WRITE(6,51)
      IF (ADD(DAT).EQ.0.0D0) THEN
        WRITE(6,159)
      ELSE
        WRITE(6,160)
        IF (DAT(1).NE.0.0D0) WRITE(6,161)DAT(1)
        IF (DAT(2).NE.0.0D0) WRITE(6,162)DAT(2)
        IF (DAT(3).NE.0.0D0) WRITE(6,163)DAT(3)
        IF (DAT(4).NE.0.0D0) WRITE(6,164)DAT(4)
        IF (DAT(5).NE.0.0D0) WRITE(6,165)DAT(5)
        IF (DAT(6).NE.0.0D0) WRITE(6,166)DAT(6)
        IF (DAT(7).NE.0.0D0) WRITE(6,167)DAT(7)
        IF (DAT(8).NE.0.0D0) WRITE(6,168)DAT(8)
        IF (DAT(9).NE.0.0D0) WRITE(6,169)DAT(9)
        IF (DAT(10).NE.0.0D0) WRITE(6,170)DAT(10)
      ENDIF
101   FORMAT(1X)
301   FORMAT('      A   e   3        P    R    O    G    R    A    M')
159   FORMAT(' Pure iron')
160   FORMAT(' The steel contains:')
161   FORMAT(F5.2,' wt% manganese')
162   FORMAT(F5.2,' wt% silicon')
163   FORMAT(F5.2,' wt% nickel')
164   FORMAT(F5.2,' wt% chromium')
165   FORMAT(F5.2,' wt% molybdenum')
166   FORMAT(F5.2,' wt% copper')
167   FORMAT(F5.2,' wt% vanadium')
168   FORMAT(F5.2,' wt% niobium')
169   FORMAT(F5.2,' wt% tungsten')
170   FORMAT(F5.2,' wt% cobalt')
******************************************************
      DO 1 I = 1,10
1     XX(I) = DAT(I)
C                   wt%
      DUMMY = 0
2     C6 = 0.0D0
      NUM = 0
      COUNT = 0
      FLAG2 = 1
      DTGAM = 0.0D0
      Z61 = 1.0D2
C
      WRITE(6,52)
      WRITE(6,57)
      WRITE(6,55)
      WRITE(6,57)
3     CONTINUE
      DO 17 N = 1,51
         IF (COUNT.EQ.-1 .OR. COUNT.EQ.12) GOTO 17
         IF (K.EQ.5 .AND. NUM.EQ.3) GOTO 17
         C = (N-1)*0.01D0
4        CONTINUE
5        WTPC = C + ADD(XX)
         IF (WTPC.GT.5.0) THEN
           WRITE(6,52)
           WRITE(6,53)
88         WRITE(6,54)
           GOTO 88
         ENDIF
C
C  CALCULATION OF MOLE FRACTIONS
C
         FEAF = (1.0D2-WTPC)/5.58D1
         CAF = C/1.2D1
         DO 6 M = 1,10
6           X(M) = XX(M)/B(M,1)
         TAF = FEAF + CAF + ADD(X)
         CF = CAF/TAF
         DO 7 M = 1,10
7        X(M) = X(M)/TAF
         CALL TZERO (CF,TO)
         T = TO
         H1 = -1.5325D4
11       CONTINUE
         CALL GALGA(G,GC,T)
         G = -G
         IF (T.GT.1.183D3) THEN
C
C VALID UP TO 1360K
C
           H = 2.549D3 - 2.746D0*T + 6.503D-4*T*T
           G = 2.476D3-5.03D0*T+3.363D-3*T*T-7.44D-7*T*T*T
         ELSE
           CALL E02BBF(NCAP7,HK,HC,T,H,IFAIL)
         ENDIF
         AC = DEXP(GC/(R*TO)+(8.91D3/T)*CF)
C
         SUM = 0.0D0
         DELTAT = 0.0D0
         DO 14 M = 1,10
            IF (X(M).EQ.0) THEN
              A(M)=0.0D0
              AI(M)=1.0D0
              GOTO 14
            ENDIF
            P = B(M,4) + B(M,5)/T
            Q = 0.0D0
            IF (M.EQ.1) THEN
C
C  DATA FROM GILMOUR ET AL., MET. TRANS., 1972
C
              GI = 6.118*T - 7808.0
            ELSE
              GI = E(M,1)+(E(M,2)+E(M,3)*T+E(M,4)*DLOG(T))*T
            ENDIF

C
C CALCULATION FOR SOLUTE PARTITION COEFFICIENTS
C
            AI(M) = DEXP(GI/(R*TO)+P*CF)
            CALL EQN(A(M),K,C,CLIQ)
            SUM = SUM + X(M)*A(M)
14       CONTINUE
         DELTAT = SUM*R*TO*TO
         T = TO+DELTAT
         Z = TT - T
         Z = DABS(Z)
         IF (Z.LT.0.5D0) GOTO 15
         TT = T
         IF (K.EQ.2) GOTO 11
15       CONTINUE
         IF (COUNT.EQ.-1) THEN
           IF (DUMMY.NE.0) TEMP = T
           GOTO 17
         ENDIF
         IF (K.EQ.3 .AND. S93.NE.3) THEN
           WRITE(6,51)
         ELSE
           IF (S91.EQ.3 .AND. N.EQ.1) GOTO 17
           IF (NUM.EQ.1) THEN
             IF (T.LT.TEMP) THEN
               COUNT = -1
               GOTO 17
             ELSE
               WRITE(6,51)
             ENDIF
           ELSE
             WRITE(6,63)C,T-273,AC
             DO 16 I = 1,10
                IF (AI(I).EQ.1.0D0) GOTO 16
                IF (I.LT.9) THEN
                  WRITE(6,65)I+1,AI(I)
                ELSE
                  WRITE(6,66)I+1,AI(I)
                ENDIF
16           CONTINUE
           ENDIF
         ENDIF
17    CONTINUE
      STOP
C
51    FORMAT(1X,62(1H-))
52    FORMAT(1X)
53    FORMAT(' The sum of the alloy components should not exceed 5wt%.')
54    FORMAT(1X,80(1H#))
55    FORMAT('       Wt%C       T/degreesC     Partition coefficients')
57    FORMAT('   +---------------------------+--------------------------
     1--+')
63    FORMAT('     ',F5.2,'       ',F6.1,'            A(c) :',F6.3)
65    FORMAT('                                   A(',I1,') :',F6.3)
66    FORMAT('                                   A(',I2,'):',F6.3)
      END

C
C  DATA FOR ALLOYING ELEMENT INTERACTION PARAMETERS
C
      BLOCK DATA ETA
      COMMON /INTER/B
      DOUBLE PRECISION B(10,5)
      DATA((B(M,J),J=1,5),M=1,10)/
     & 5.49D1,0.0D0,-5.06D3,0.0D0,-5.07D3,
     & 2.81D1,-4.28D-1,1.874D4,4.84D0,-7.37D3,
     & 5.87D1,0.0D0,5.34D3,-2.2D0,7.6D3,
     & 5.20D1,0.0D0,-9.5D3,2.44D1,-3.84D4,
     & 9.59D1,0.0D0,-7.49D3,3.855D0,-1.787D4,
     & 6.35D1,0.0D0,7.586D3,0.0D0,4.2D3,
     & 5.09D1,0.0D0,-3.01D4,0.0D0,-2.466D4,
     & 9.29D1,0.0D0,-4.6615D4,0.0D0,-2.877D4,
     & 1.838D2,0.0D0,-1.223D4,2.34D1,-3.6214D4,
     & 5.89D1,0.0D0,3.55D3,0.0D0,2.8D3/
      END

C
C  DATA FOR ALLOYING ELEMENT FREE ENERGY CHANGES (DELTA G(I))
C  [FERRITE-AUSTENITE TRANSORMATION]
C
      BLOCK DATA DGI2
      COMMON /DELTA2/E
      DOUBLE PRECISION E(10,4)
      DATA((E(M,J),J=1,4),M=1,10)/
     & -2.665D4,4.269D1,-1.7D-2,0.0D0,
     & -5.964D3,3.8799D1,0.0D0,-4.7244D0,
     & -4.545D3,3.233D0,0.0D0,0.0D0,
     & -3.67D2,-4.656D0,0.0D0,6.568D-1,
     &  5.65D2,1.5D-1,0.0D0,0.0D0,
     & -2.55D4,4.1183D1,-1.7D-1,0.0D0,
     & -8.357D3,1.38D1,-5.1D-3,0.0D0,
C
C  NIOBIUM RECALCULATED
C  REF: A.A.B.SUGDEN, C.P.G.S DISSERTATION, 1986
C
     & 5.139D3,-2.892D0,0.0D0,0.0D0,
     & 2.5D3,1.5D-1,0.0D0,0.0D0,
     & 0.0D0,0.0D0,0.0D0,0.0D0/
      END

      DOUBLE PRECISION FUNCTION ADD(Y)
      DOUBLE PRECISION Y(10)
      ADD = 0.0D0
      DO 4 I = 1,10
4     ADD = ADD + Y(I)
      RETURN
      END


C
C  THIS SECTION CONTAINS 2 SUBROUTINES TO FIND
C  To AND DELTAGo RESPECTIVELY
C
      SUBROUTINE TZERO (X1,T1)
C
C  DATA PROVIDED BY BHADESHIA
C  RANGE 200-900 CENTIGRADE
C
      DOUBLE PRECISION X1,T1
      IF (X1.GE.6.88D-2) GOTO 1
      IF (X1.LT.1.0D-3) THEN
        T1 = 9.115D2 - 2.12D4*X1 + 3.45D6*X1*X1
      ELSE
        IF (X1.LT.3.135D-2) THEN
          T1 = 9.056D2-1.068D4*X1+2.811D5*X1*X1-3.913D6*(X1**3)
        ELSE
          IF (X1.LT.4.84D-2) THEN
            T1 = 8.558D2 - 4.694D3*X1 + 2.156D4*X1*X1
          ELSE
            T1 = 7.475D2 - 1.449D3*X1 - 7.163D3*X1*X1
          ENDIF
        ENDIF
      ENDIF
      GOTO 2
1     CONTINUE
      IF (X1.LT.9.33D-2) THEN
        T1 = 6.152D2 + 1.779D3*X1 - 2.677D4*X1*X1
      ELSE
        IF (X1.LT.1.526D-1) THEN
          T1 = 5.168D2 + 5.017D3*X1 - 6.693D4*X1*X1
          T1 = T1 + 1.823D5*(X1**3)
        ELSE
          T1 = 6.922D2 - 1.087D3*X1 - 6.696D3*X1*X1
        ENDIF
      ENDIF
2     CONTINUE
      T1 = T1 + 273
      RETURN
      END

      SUBROUTINE GALGA (G2,GC2,T2)
C
C  DATA DUE TO KAUFMAN, CLOUGHERTY, AND WEISS
C  (RANGE 0-1183K)
C
      DOUBLE PRECISION G2,GC2,T2
      IF (T2.LT.7.0D2) THEN
        IF (T2.LT.3.0D2) THEN
          G2 = 1.38D0*T2 - 1.499D3
        ELSE
          G2 = 1.65786D0*T2 - 1.581D3
        ENDIF
      ELSE
        IF (T2.LT.9.4D2) THEN
          G2 = 1.30089D0*T2 - 1.331D3
        ELSE
          G2 = - 8.89909D0 + 2.6557D-1*(T2-1.14D3)
          G2 = G2 - 1.04923D-3*(T2-1.14D3)*(T2-1.14D3)
          G2 = G2 + 2.70013D-6*((T2-1.14D3)**3)
          G2 = G2 - 3.58434D-9*((T2-1.14D3)**4)
C
C  CORRECTED DATA PROVIDED BY BHADESHIA AND YANG
C
        ENDIF
      ENDIF
      GC2 = 7.686D0*T2 - 1.5325D4
      RETURN
      END


      SUBROUTINE EQN (F16,NO,CC,CQIL)
      IMPLICIT DOUBLE PRECISION (F)
      DOUBLE PRECISION G,R,TO,T,P,CF,Q,GC,GI,H1,H
      DOUBLE PRECISION CC,CQIL,EG11,EL11
      COMMON /PARMS/G,R,TO,T,P,CF,Q,GC,GI,H1,H
C
C  SET CARBON-CARBON INTERACTION PARAMETERS
C
      EG11 = 0.0D0
      EL11 = 8.91D3/T
C
C  MAIN EQUATION
C
      F1 = GI/(R*TO) + P*CF
      F2 = GC/(R*TO)
      F3 = 1 + Q*CF*DEXP(F2)
      F4 = GC/(R*TO) + (EL11)*CF
      F5 = 1 + EG11*CF*DEXP(F2)
      F6 = DEXP(F1)/F3
      F7 = DEXP(F4)/F5
      F8 = 1+CF*(1-CF)*(P-Q*F6*F7)
      F9 = G/(R*TO*TO)
      F10 = CF*CF/2*((EL11)-(EG11*F7*F7))
      F11 = DEXP(F4)*CF*H1/F5
      F12 = (1-CF)*H
      F13 = F9 - F10
      F14 = F11+F12*DEXP(F13)
      F15 = F8*DEXP(F13)
      F16 = (F6-F15)/F14
      RETURN
      END
